package com.izouma.nineth.web;

import com.izouma.nineth.domain.ExceptionLog;
import com.izouma.nineth.dto.PageQuery;
import com.izouma.nineth.exception.BusinessException;
import com.izouma.nineth.repo.ExceptionLogRepo;
import com.izouma.nineth.service.ExceptionLogService;
import com.izouma.nineth.utils.ObjUtils;
import com.izouma.nineth.utils.excel.ExcelUtils;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

import static com.izouma.nineth.utils.JpaUtils.toPageRequest;
import static com.izouma.nineth.utils.JpaUtils.toSpecification;

@RestController
@RequestMapping("/exceptionLog")
@AllArgsConstructor
public class ExceptionLogController extends BaseController {
    private ExceptionLogService exceptionLogService;
    private ExceptionLogRepo    exceptionLogRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public ExceptionLog save(@RequestBody ExceptionLog record) {
        if (record.getId() != null) {
            ExceptionLog orig = exceptionLogRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return exceptionLogRepo.save(orig);
        }
        return exceptionLogRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<ExceptionLog> all(@RequestBody PageQuery pageQuery) {
        return exceptionLogRepo.findAll(toSpecification(pageQuery, ExceptionLog.class), toPageRequest(pageQuery));
    }

    @GetMapping("/get/{id}")
    public ExceptionLog get(@PathVariable Long id) {
        return exceptionLogRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        exceptionLogRepo.deleteById(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<ExceptionLog> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

